(*
 Kdkszlet: IBM852.
 Krem a Geanyben ennek megfelel belltssal jraolvasni!
 
 Az elfordtnak szl "{$DEFINE TESZTKIIRAS}" szimblumdefinicit
 "lv tenni", ha nem csupn lineris egyenletrendszer eredmnyre, 
 hanem a szmts menetre is kvncsi.
*)

Program GaussJordanProba;
{$DEFINE TESZTKIIRAS}
  Uses
    Crt;
  Const
    EPS=1.0E-9;//Pontossg
{A Szidaronszky:"Bevezets a numerikus mdszerekbe" knyv 177.o.-i pldja:}
    MaxN=3;
{Az FV1.pdf-ben szerepl plda:
    MaxN=6;
}
  Type
    TVektor=Array [1..MaxN] of Real;
    TMatrix=Array [1..MaxN] of TVektor;
  Const
{A Szidaronszky:"Bevezets a numerikus mdszerekbe" knyv 177.o.-i pldja:}
    A0:TMatrix=((2,1,1),
                (1,3,2),
                (1,2,2));
    b0:TVektor=(4,6,5);
{Az FV1.pdf-ben szerepl plda:
    A0:TMatrix=((0,0,1,0,0,0),
                (1,1,1,0,0,0),
                (4,2,1,0,0,0),
                (0,0,0,4,2,1),
                (0,0,0,9,3,1),
                (4,1,0,-4,-1,0));
    b0:TVektor=(3,4,1,1,4,0);
}
  Var
    A:TMatrix;
    b,x:TVektor;
    N,i,j:Integer;
 
{$IFDEF TESZTKIIRAS}
Procedure EgyenletKi(Const a:TMatrix; Const b:TVektor; 
                     Const n:Integer; Const s:String);
  Var
    i,j:Integer;
Begin
  Writeln('**** ',s,' ****');
  Writeln(' ':n*3-1,'A-mtrix',' ':n*3-2,'=b-vektor');
  For i:=1 to n do
  Begin
    Write(i:3,': ');
    For j:=1 to n do Write(a[i,j]:5:2,' ');
    Writeln('= ',b[i]:5:2);
  End;
  ReadKey;
End;

Function int2str(Const x:Integer):String;
  Var
    sx:String;
Begin
  Str(x,sx);
  int2str:=sx
End;
{$ENDIF}

    Operator *(x,y:TVektor) xy:Real;
    {x*y=x,y skalris szorzata; x,y:N-dimenzisak; N:globlis paramter}
      Var
        i:Integer;
    Begin
      xy:=0.0;
      For i:=1 to N do xy:=xy+x[i]*y[i]
    End;
    
    Procedure Csere(Var x,y:Real);
      Var
        s:Real;
    Begin
      s:=x; x:=y; y:=s;
    End;
    
	Function GJ(Var a:TMatrix; Var b:TVektor; Const n:Integer):Boolean;
  	  Var
  	    i,ll,l,maxI:Integer;
	    reciprok,s,max:Real;
	Begin
{$IFDEF TESZTKIIRAS}
EgyenletKi(a,b,n,'Kezdetben.');
{$ENDIF}
	  For i:=1 to n do
	  Begin
		//rszleges felem-kivlaszts:
		//felem-kivlaszts az i. oszlopban i.-tl kezdve:
		maxI:=0; max:=0.0;
		For l:=i to n do
		Begin
		  If max<abs(a[l,i]) then
		  Begin
			maxI:=l; max:=abs(a[l,i]);
		  End;
		End;
		If maxI=0 then//szingularits
		Begin
		  GJ:=False; Exit;
		End;
{$IFDEF TESZTKIIRAS}
Writeln('****',#10#13,
        'A(z) ',i,'. oszlop legnagyobbja:',a[maxI,i]:5:2,' (',maxI,')',#10#13,
        '****');
{$ENDIF}
		//Folytathat:
		If maxI<>i then//sorcsere(i,maxI)
		Begin
		  For l:=1 to n do Csere(a[i,l],a[maxI,l]);
		  Csere(b[i],b[maxI]);
{$IFDEF TESZTKIIRAS}
EgyenletKi(a,b,n,'A sorcsere utn.');
{$ENDIF}
		End;
		//i. sor transzformlsa:
		reciprok:=1.0/a[i,i];
		For l:=1 to n do a[i,l]:=a[i,l]*reciprok;
		b[i]:=b[i]*reciprok;
		//a nem i. sor transzformlsa:
		For ll:=1 to n do
		Begin
		  If ll<>i then
		  Begin
			s:=a[ll,i];
			for l:=1 to n do a[ll,l]:=a[ll,l]-a[i,l]*s;
			b[ll]:=b[ll]-b[i]*s ;
		  End;
		End;
{$IFDEF TESZTKIIRAS}
EgyenletKi(a,b,n,'A(z) '+int2str(i)+' transzformci utn.');
{$ENDIF}
	  End;
      GJ:=True;
	End;

    Function Ellenorzes(Const a:TMatrix; Const b,x:TVektor; 
                        Const n:Integer):Integer;
    {Az a*x=b vektoregyenlet ellenrzse.}
       Var
         i:Integer;
         megOk:Boolean;
    Begin
      megOK:=True;
      i:=1;
      While (i<=n) and megOK do
      Begin
        megOK:=Abs(a[i]*b-x[i])<EPS;
        Inc(i);
      End;
      Ellenorzes:=i;
    End;
    
Begin
  ClrScr;
  N:=MaxN; A:=A0; b:=b0;
  If GJ(A,b,N) then
  Begin
    x:=b;
    Writeln('x-vektor:');
    For i:=1 to N do Writeln(i:3,'.:',x[i]:5:2);
    ReadKey;
    j:=Ellenorzes(A,b,x,N);
    Write('Az "Ax=b" vektoregyenlet teljesl ',EPS:0:9,'-pontossggal? ');
    If j>N then
      Writeln('OK.')
    else
      Writeln('Nem OK:',j,'.');
  End
    Else
  Begin
    Writeln('Az egytthatmtrix szingulris.');
  End;
  ReadKey;
End.
