(*
 Kdkszlet: IBM852.
 Krem a Geanyben ennek megfelel belltssal jraolvasni!
 
 Az elfordtnak szl "{$DEFINE TESZTKIIRAS}" szimblumdefinicit
 "lv tenni", ha nem csupn lineris egyenletrendszer eredmnyre, 
 hanem a szmts menetre is kvncsi.
 
 A szomszdos kt pontra fektetett parabols rendszer, amelyben a 
 csatlakoz parabolk rinti azonosak, s a szls rintk egyms
 -1-szerese.
*)

Program GaussJordanParabolaIllaszteshez;
//{$DEFINE TESZTKIIRAS}
  Uses
    Crt;
  Const
    EPS=1.0E-9;//Pontossg
    MaxP=5;//pontok szma
    MaxN=(MaxP-1)*3;//ismeretlenek szma=egytthatmtrix rendje
  Type
    TPontok=Array [1..MaxP] of Record x,y:Real End;
    TVektor=Array [1..MaxN] of Real;
    TMatrix=Array [1..MaxN] of TVektor;
  Const
    p:TPontok=((x:0;y:1),(x:1;y:4),(x:2;y:-2),(x:3;y:4),(x:4;y:1));
  Var
    A:TMatrix;
    b,x:TVektor;
    pDb,N,i,j:Integer;

{$IFDEF TESZTKIIRAS}
Procedure EgyenletKi(Const a:TMatrix; Const b:TVektor; 
                     Const n:Integer; Const s:String);
  Var
    i,j:Integer;
Begin
  Writeln('**** ',s,' ****');
  Writeln(' ':n*3-1,'A-mtrix',' ':n*3-2,'=b-vektor');
  For i:=1 to n do
  Begin
    Write(i:3,': ');
    For j:=1 to n do Write(a[i,j]:5:2,' ');
    Writeln('= ',b[i]:5:2);
  End;
  ReadKey;
End;

Function int2str(Const x:Integer):String;
  Var
    sx:String;
Begin
  Str(x,sx);
  int2str:=sx
End;
{$ENDIF}

    Operator *(x,y:TVektor) xy:Real;
    {x*y=x,y skalris szorzata; x,y:N-dimenzisak; N:globlis paramter}
      Var
        i:Integer;
    Begin
      xy:=0.0;
      For i:=1 to N do xy:=xy+x[i]*y[i]
    End;

    Procedure Csere(Var x,y:Real);
      Var
        s:Real;
    Begin
      s:=x; x:=y; y:=s;
    End;

	Function GJ(Var a:TMatrix; Var b:TVektor; Const n:Integer):Boolean;
	  Var
	    i,ll,l,maxI:Integer;
	    reciprok,s,max:Real;
	Begin
{$IFDEF TESZTKIIRAS}
EgyenletKi(a,b,n,'Kezdetben.');
{$ENDIF}
	  For i:=1 to n do
	  Begin
		//rszleges felem-kivlaszts:
		//felem-kivlaszts az i. oszlopban i.-tl kezdve:
		maxI:=0; max:=0.0;
		For l:=i to n do
		Begin
		  If max<abs(a[l,i]) then
		  Begin
			maxI:=l; max:=abs(a[l,i]);
		  End;
		End;
		If maxI=0 then
		Begin
		  GJ:=False; Exit;
		End;
{$IFDEF TESZTKIIRAS}
Writeln('****',#10#13,
        'A(z) ',i,'. oszlop legnagyobbja:',a[maxI,i]:5:2,' (',maxI,')',#10#13,
        '****');
{$ENDIF}
		//Folytathat:
		If maxI<>i then//sorcsere(i,maxI)
		Begin
		  For l:=1 to n do Csere(a[i,l],a[maxI,l]);
		  Csere(b[i],b[maxI]);
{$IFDEF TESZTKIIRAS}
EgyenletKi(a,b,n,'A sorcsere utn.');
{$ENDIF}
		End;
		//i. sor transzformlsa:
		reciprok:=1.0/a[i,i];
		For l:=1 to n do a[i,l]:=a[i,l]*reciprok;
		b[i]:=b[i]*reciprok;
		//a nem i. sor transzformlsa:
		For ll:=1 to n do
		Begin
		  If ll<>i then
		  Begin
			s:=a[ll,i];
			for l:=1 to n do a[ll,l]:=a[ll,l]-a[i,l]*s;
			b[ll]:=b[ll]-b[i]*s ;
		  End;
		End;
{$IFDEF TESZTKIIRAS}
EgyenletKi(a,b,n,'A(z) '+int2str(i)+' transzformci utn.');
{$ENDIF}
	  End;
      GJ:=True;
	End;

    Function EgyutthatoMatrix(Const p:TPontok; Const n:Integer):TMatrix;
    {ha a pontokszma pDb, akkor a parabolavek (fi)szma pDb-1,
     mivel minden parabola 2 pontra illeszkedik}
      Var
        i,j,k,fDb:Integer;
        a:TMatrix;
    Begin
      For i:=1 to MaxN do for j:=1 to MaxN do a[i,j]:=0.0;
      //az sszes parabola pontokra fektetse: 1..2*(pDb-1) sor:
      For k:=1 to pDb-1 do
      Begin
        fDb:=2*k-1;//akt. parabola sorszma
        j:=3*k-2;//akt. parabola 1. paramternek oszlopindexe
        //f(fDb)(pk.x)=pk.y (k=1..pDb-1):
        a[fDb,j]:=Sqr(p[k].x); a[fDb,j+1]:=p[k].x; a[fDb,j+2]:=1;
        //f(fDb)(p(k+1).x)=p(k+1).y (k=1..pDb-1):
        a[fDb+1,j]:=Sqr(p[k+1].x); a[fDb+1,j+1]:=p[k+1].x; a[fDb+1,j+2]:=1;
      End;
      //kzbls pontokon az rintk azonosak: 2*pDb-1..3*pDb-3 sor:
      i:=2*pDb-2;//ennyi sort tltttnk eddig ki
      For k:=1 to pDb-2 do
      Begin
        Inc(i);//akt. sor indexe
        j:=3*k-2;//akt. parabola 1. paramternek oszlopindexe
        //fk'(p(k+1).x)-f(k+1)(p(k+1).x=0   (k=1..pDb-2):
        a[i,j]:=2*p[k+1].x;    a[i,j+1]:=1;  a[i,j+2]:=0;
        a[i,j+3]:=-2*p[k+1].x; a[i,j+4]:=-1; a[i,j+5]:=0;
      End;
      //szls pontokon az rintk ellenttesek: 3*pDb-2. sor:
//      i:=2*pDb-2;//ennyi sort tltttnk eddig ki
      Inc(i);//ennyiedik sornl tartunk
      //f1'(p(1).x)+f(pDb-1)(p(pDb).x=0:
      a[i,1]:=2*p[1].x;    a[i,2]:=1;  a[i,3]:=0;
      j:=3*pDb-5;//pDb. parabola 1. paramternek oszlopindexe
      a[i,j]:=2*p[i+1].x; a[i,j+1]:=1; a[i,j+2]:=0;
      EgyutthatoMatrix:=a;
    End;

    Function BVektor(Const p:TPontok; Const n:Integer):TVektor;
      Var
        i,k,fDb:Integer;
        b:TVektor;
    Begin
      For i:=1 to MaxN do b[i]:=0.0;
      //az sszes parabola pontokra fektetse: 1..2*(pDb-1) sor:
      For k:=1 to pDb-1 do
      Begin
        fDb:=2*k-1;//akt. parabola sorszma
        //f(fDb)(pk.x)=pk.y (k=1..pDb-1):
        b[fDb]:=p[k].y;
        //f(fDb)(p(k+1).x)=p(k+1).y (k=1..pDb-1):
        b[fDb+1]:=p[k+1].y;
      End;
      //kzbls pontokon az rintk azonosak: 2*pDb-1..3*pDb-3 sor:
      i:=2*pDb-2;//ennyi sort tltttnk eddig ki
      For k:=1 to pDb-2 do
      Begin
        Inc(i);//a kvetkez sort tltjk ki
        j:=3*k-2;//akt. parabola 1. paramternek oszlopindexe
        //fk'(p(i+1).x)-f(k+1)(p(i+1).x=0   (k=1..pDb-2):
        b[i]:=0;
      End;
      //szls pontokon az rintk ellenttesek: 3*pDb-2. sor:
//      i:=2*pDb-2;//ennyi sort tltttnk eddig ki
      Inc(i);//ennyiedik sornl tartunk
      //f1'(p(1).x)+f(pDb-1)(p(pDb).x=0:
      b[i]:=0;
      BVektor:=b;
    End;

    Function Ellenorzes(Const a:TMatrix; Const b,x:TVektor;
                        Const n:Integer):Integer;
    {Az a*x=b vektoregyenlet ellenrzse.}
       Var
         i:Integer;
         megOk:Boolean;
    Begin
      megOK:=True;
      i:=1;
      While (i<=n) and megOK do
      Begin
        megOK:=Abs(a[i]*b-x[i])<EPS;
        Inc(i);
      End;
      Ellenorzes:=i;
    End;

    Function Ellenorzes2(Const p:TPontok; Const pDb:Integer;
                         Const x:TVektor):Integer;
    {A p[1.pDb] pontokon tmen parabolk ellenrzse.}
       Var
         i,j:Integer;//i:parabolasorszm; j:pontsorszm
         megOk:Boolean;
         a,b,c:Real;

       Function Parabola(Const a,b,c,x:Real):Real;
       Begin
         Parabola:=a*Sqr(x)+b*x+c;
       End;

    Begin
      megOK:=True;
      i:=1;
      While (i<=pDb-1) and megOK do
      Begin
        a:=x[i*3-2]; b:=x[i*3-1]; c:=x[i*3];
        j:=i;
        megOK:=Abs(Parabola(a,b,c,p[j].x)-p[j].y)<EPS;
        If megOK then
        Begin
          j:=i+1;
          megOK:=Abs(Parabola(a,b,c,p[j].x)-p[j].y)<EPS;
          If megOk then Inc(i);
        End;
      End;
      Ellenorzes2:=i*10+j;
    End;

Begin
  ClrScr;
  pDb:=MaxP; N:=(pDb-1)*3;
  A:=EgyutthatoMatrix(p,pDb); b:=BVektor(p,pDb);
  If GJ(A,b,N) then
  Begin
    x:=b;
    Writeln('x-vektor:');
    For i:=1 to N do Writeln(i:3,'.=',x[i]:5:2);
    ReadKey;
    j:=Ellenorzes(A,b,x,N);
    Write('Az "Ax=b" vektoregyenlet teljesl ',EPS:0:9,'-pontossggal? ');
    If j>N then
      Writeln('OK.')
    else
      Writeln('Nem OK:',j,'.');
    j:=Ellenorzes2(p,pDb,x);
    Write('A "parabolk a pontokon tmennek" llts teljesl ',
          EPS:0:9,'-pontossggal? ');
    If j>10*(pDb-1) then
      Writeln('OK.')
    else
      Writeln('Nem OK:',j Div 10,'. parabola, ',j Mod 10,'. ponton.');
  End
    Else
  Begin
    Writeln('Az egytthatmtrix szingulris.');
  End;
  ReadKey;
End.
